"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PriorityQueue = void 0;
var PriorityQueue = /** @class */ (function () {
    function PriorityQueue() {
        this.elements = [];
    }
    PriorityQueue.prototype.enqueue = function (value, priority) {
        this.elements.push({ value: value, priority: priority });
    };
    PriorityQueue.prototype.dequeue = function () {
        var index = -1;
        var maxPriority = -Infinity;
        for (var i = 0; i < this.elements.length; i++) {
            if (this.elements[i].priority > maxPriority) {
                index = i;
                maxPriority = this.elements[i].priority;
            }
        }
        if (index !== -1) {
            var value = this.elements[index].value;
            this.elements.splice(index, 1);
            return value;
        }
    };
    PriorityQueue.prototype.isEmpty = function () {
        return this.elements.length === 0;
    };
    return PriorityQueue;
}());
exports.PriorityQueue = PriorityQueue;
//# sourceMappingURL=PriorityQueue.js.map