var Query = /** @class */ (function () {
    function Query(components, entities) {
        this.components = components;
        this.entities = [];
        this.indices = new Map();
        for (var _i = 0, entities_1 = entities; _i < entities_1.length; _i++) {
            var entity = entities_1[_i];
            this.onChange(entity);
        }
    }
    Query.prototype.onChange = function (entity) {
        if (this.components.every(function (component) { return entity.has(component); })) {
            if (this.indices.get(entity) == null) {
                this.indices.set(entity, this.entities.length);
                this.entities.push(entity);
            }
        }
        else {
            this.onRemove(entity);
        }
    };
    Query.prototype.onRemove = function (entity) {
        var index = this.indices.get(entity);
        if (index != null) {
            var last = this.entities.pop();
            if (last !== entity) {
                this.entities[index] = last;
                this.indices.set(last, index);
            }
            this.indices.delete(entity);
        }
    };
    return Query;
}());
export { Query };
//# sourceMappingURL=Query.js.map