import { Entity } from './Entity';
import { Component } from './Component';
import { System } from './System';
export declare class World {
    private systems;
    private entityManager;
    constructor(systems: System<any>[]);
    private running;
    private events;
    query(...components: Component<any>[]): readonly Entity[];
    queryOne(...components: Component<any>[]): Entity | undefined;
    create(): Entity;
    remove(entity: Entity): void;
    emit(event: any, priority?: number): void;
    run(callback: () => void): void;
    private ensureRunning;
}
